<template>
  <!-- ฟอร์มกรอกข้อมูลที่ต้องการแก้ไข -->
  <form @submit.prevent="submit">
    <v-text-field
      v-model="fname.value.value"
      :error-messages="fname.errorMessage.value"
      label="First Name"
    ></v-text-field>
    <v-text-field
      v-model="lname.value.value"
      :error-messages="lname.errorMessage.value"
      label="Last Name"
    ></v-text-field>
    <v-text-field
      v-model="username.value.value"
      :error-messages="username.errorMessage.value"
      label="Username"
    ></v-text-field>
    <v-text-field
      v-model="password.value.value"
      :error-messages="password.errorMessage.value"
      label="Password"
    ></v-text-field>
    <v-text-field
      v-model="email.value.value"
      :error-messages="email.errorMessage.value"
      label="Email"
    ></v-text-field>
    <v-text-field
      v-model="avatar.value.value"
      :error-messages="avatar.errorMessage.value"
      label="Avata"
    ></v-text-field>
    <!-- Submit and Clear buttons -->
    <v-btn class="me-4" type="submit"> submit </v-btn>
    <v-btn @click="handleReset"> clear </v-btn>
  </form>
</template>

<script>
import { ref, onMounted } from "vue";
import { useField, useForm } from "vee-validate";
import { useRouter, useRoute } from "vue-router";

export default {
  setup() {
    const router = useRouter();
    const route = useRoute();
    const id = route.params.id;

    const { handleSubmit,handleReset } = useForm({
    // การตรวจสอบสำหรับการกรอกข้อมูลในแบบฟอร์ม
      validationSchema: {
        // Frist name
        fname(value) {
          if (value?.length >= 2) return true;

          return "First name needs to be at least 2 characters.";
        },
        // Last name
        lname(value) {
          if (value?.length >= 2) return true;

          return "Last name needs to be at least 2 characters.";
        },
        // Username
        username(value) {
          if (value?.length >= 2) return true;

          return "Username needs to be at least 6 characters.";
        },
        // Password
        password (value) {
            if (value?.length >= 8) return true

            return 'Password needs to be at least 8 characters.'
        },
        // Email
        email (value) {
            if (/^[a-z.-]+@[a-z.-]+\.[a-z]+$/i.test(value)) return true

            return 'Must be a valid e-mail.'
        },
        // Avatar
        avatar (value) {
            if (value?.length >= 1) return true

            return 'avatar needs to link avatar.'
        },
      },
    });

    const fname = useField("fname");
    const lname = useField("lname");
    const username = useField("username");
    const password = useField("password");
    const email = useField("email");
    const avatar = useField("avatar");

    const runtimeConfig = useRuntimeConfig();
    const URL = runtimeConfig.public.URL_Auth;
    console.log("URL : ",URL)

    const fetchData = async () => {
      try {
        const response = await fetch(`${URL}/api/users/${id}`);
        const userData = await response.json();
        
        fname.value.value = userData.user.fname;
        lname.value.value = userData.user.lname;
        username.value.value = userData.user.username;
        password.value.value = userData.user.password;
        email.value.value = userData.user.email;
        avatar.value.value = userData.user.avatar;

        console.log("Fetched data:", userData);
        console.info("info data:", userData.user);
        console.debug("DeBug Fetched data:", userData.user);
        console.error("Error Fetched data:", userData.user);

      } catch (error) {
        console.log("error", error);
      }
    };

    const submit = handleSubmit(async () => {
      try {
        const myHeaders = new Headers();
        myHeaders.append("Content-Type", "application/json");
        
        const editedData = {
          "id": id, 
          "fname": fname.value.value,
          "lname": lname.value.value,
          "username": username.value.value,
          "password": password.value.value,
          "email": email.value.value,
          "avatar": avatar.value.value,
        };
        console.log("Before edited to sent", editedData) // console.log ก่อนส่งข้อมูลการแก้ไขข้อมูลว่าแก้ไขอะไรบ้าง
        console.info("Before info edited data:", editedData); // console.log ก่อนส่งข้อมูลการแก้ไขข้อมูลว่าแก้ไขอะไรบ้าง
        console.debug("Before DeBug Fetched edited data:", editedData); // console.log ตรวจหา deBug ก่อนส่งข้อมูลไป
        console.error("Before Error Fetched edited data:", editedData); // console.log ตรวจหา error ก่อนส่งข้อมูลไป

        const raw = JSON.stringify(editedData);     
        const requestOptions = {
          method: "PUT",
          headers: myHeaders,
          body: raw,
          redirect: "follow",
        };
        
        const response = await fetch(`${URL}/api/users/update`, requestOptions);
        const result = await response.json();

        alert("Edited this id: " + id + " success");  // แจ้งเตือนการแก้ไขข้อมูล
        console.log('After edited data:', editedData); // console.log การแก้ไขข้อมูลหลังจากถูกแก้ไขว่าแก้ไขอะไรบ้าง
        console.info('After info edited data:', editedData); // console.log การแก้ไขข้อมูลหลังจากถูกแก้ไขว่าแก้ไขอะไรบ้าง
        console.debug('After DeBug edited data:', editedData); // console.log ตรวจหา deBug หลังจากส่งข้อมูลไปแล้ว
        console.error('After Error edited data:', editedData); // console.log ตรวจหา error หลังจากส่งข้อมูลไปแล้ว
        
        const currentDate = new Date();
        const formattedDate = currentDate.toLocaleDateString() + ' ' + currentDate.toLocaleTimeString();
        console.log('Edit data at:', formattedDate);   // console.log วันและเวลาที่เพิ่มข้อมูล
        console.log("Status = ",result.status)
        if (result.status === "ok") {
          router.push("/kissada/tableAPI"); 
        }
      } catch (error) {
        console.log("Error edit data ", error);
      }
    });

    onMounted(() => {
      fetchData();
    });

    return {
      fname,
      lname,
      username,
      password,
      email,
      avatar,
      submit,
      handleReset,
    };
  },
};
</script>